Panda3D

Loading...
Searching...
No Matches
Public Member Functions | Public Attributes | Static Public Attributes | List of all members
MopathRecorder Class Reference
Inheritance diagram for MopathRecorder:

## Public Member Functions
| __init__ (self, parent=None, **kw)
| addKeyframe (self, fToggleRecord=1)
| addNodePath (self, nodePath)
| addNodePathToDict (self, nodePath, names, menu, dict)
| addWidget (self, widget, category, text)
| WIDGET UTILITY FUNCTIONS ##.
| appInit (self)
| USER METHODS ### To be overridden.
| computeCurves (self)
| createAngleDial (self, parent, category, text, balloonHelp, command=None, **kw)
| createButton (self, parent, category, text, balloonHelp, command, side='top', expand=0, fill=X)
| createCheckbutton (self, parent, category, text, balloonHelp, command, initialState, side='top', fill=X, expand=0)
| createColorEntry (self, parent, category, text, balloonHelp, command=None, **kw)
| createComboBox (self, parent, category, text, balloonHelp, items, command, history=0, side=LEFT, expand=0, fill=X)
| createEntryScale (self, parent, category, text, balloonHelp, command=None, min=0.0, max=1.0, resolution=None, side=TOP, fill=X, expand=1, **kw)
| createFloater (self, parent, category, text, balloonHelp, command=None, min=0.0, resolution=None, maxVelocity=10.0, **kw)
| createInterface (self)
| createLabeledEntry (self, parent, category, text, balloonHelp, value='', command=None, relief='sunken', side=LEFT, expand=1, width=12)
| createNewPointSet (self)
| createOptionMenu (self, parent, category, text, balloonHelp, items, command)
| createRadiobutton (self, parent, side, category, text, balloonHelp, variable, value, command=None, fill=X, expand=0)
| createSlider (self, parent, category, text, balloonHelp, command=None, min=0.0, max=1.0, resolution=None, side=TOP, fill=X, expand=1, **kw)
| createVector2Entry (self, parent, category, text, balloonHelp, command=None, **kw)
| createVector3Entry (self, parent, category, text, balloonHelp, command=None, **kw)
| cropCurve (self)
| curveEditTask (self, state)
| desampleCurve (self)
| deselectedNodePathHook (self, nodePath)
| disableKeyframeButton (self)
| easeInOut (self, t)
| enableKeyframeButton (self)
| extractPointSetFromCurveCollection (self)
| extractPointSetFromCurveFitter (self)
| faceForward (self)
| followTerrain (self, height=1.0)
| getChildIds (self, nodePath)
| getPostPoints (self)
| getPrePoints (self, type='Refine')
| getVariable (self, category, text)
| getWidget (self, category, text)
| initTrace (self)
| jumpToEndOfPlayback (self)
| jumpToStartOfPlayback (self)
| loadCurveFromFile (self)
| makeCameraWindow (self)
| makeEven (self)
| manipulateObjectCleanupHook (self, nodePathList=[])
| manipulateObjectStartHook (self)
| mergePoints (self)
| onDestroy (self, event)
| playbackGoTo (self, time)
| playbackTask (self, state)
| pushRedo (self)
| pushRedoHook (self)
| pushUndo (self, fResetRedo=1)
| pushUndoHook (self)
| recordPoint (self, time)
| recordTask (self, state)
| redoHook (self, nodePathList=[])
| redoListEmptyHook (self)
| reset (self)
| sampleCurve (self, fCompute=1)
| saveCurveToFile (self)
| selectedNodePathHook (self, nodePath)
| selectNodePathNamed (self, name)
| selectPointSetNamed (self, name)
| setControlStart (self, value)
| setControlStop (self, value)
| setCropFrom (self, value)
| setCropTo (self, value)
| setCvColor (self, color)
| setCvVis (self)
| setDesampleFrequency (self, frequency)
| setExtendMode (self)
| setHullColor (self, color)
| setHullVis (self)
| setKeyframeHook (self, event=None)
| setKnotColor (self, color)
| setKnotVis (self)
| setLoopPlayback (self)
| setMarkerVis (self)
| setNewCurveMode (self)
| setNodePath (self, nodePath)
| setNumSamples (self, numSamples)
| setNumSegs (self, value)
| setNumTicks (self, value)
| setPathColor (self, color)
| setPathDuration (self, event)
| setPathDurationTo (self, newMaxT)
| setPathVis (self)
| setPlaybackNodePath (self, nodePath)
| setPlaybackSF (self, value)
| setPreRecordFunc (self, func)
| setRecordingType (self, type)
| setRecordStart (self, value)
| setRefineMode (self)
| setRefineStop (self, value)
| setSamplingMode (self, mode)
| setSpeedScale (self, value)
| setStartStopHook (self, event=None)
| setTickColor (self, color)
| setTickScale (self, value)
| setTraceVis (self)
| startPlayback (self)
| startStopPlayback (self)
| stopPlayback (self)
| toggleRecord (self)
| toggleRecordVar (self)
| undoHook (self, nodePathList=[])
| undoListEmptyHook (self)
| updateWidgets (self)
Public Member Functions inherited from AppShell
| __init__ (self, parent=None, **kw)
| addVariable (self, category, text, variable)
| alignbuttons (self)
| balloon (self)
| bind (self, child, balloonHelpMsg, statusHelpMsg=None)
| buttonAdd (self, buttonName, helpMessage=None, statusMessage=None, **kw)
| buttonBox (self)
| createMenuBar (self)
| createWidget (self, parent, category, text, widgetClass, help, command, side, fill, expand, kw)
| interior (self)
| messageBar (self)
| newCreateButton (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateCheckbutton (self, parent, category, text, help='', command=None, initialState=0, anchor=W, side=LEFT, fill=X, expand=0, **kw)
| newCreateColorEntry (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateComboBox (self, parent, category, text, help='', command=None, items=[], state=DISABLED, history=0, labelpos=W, label_anchor=W, label_width=16, entry_width=16, side=LEFT, fill=X, expand=0, **kw)
| newCreateDial (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateEntryScale (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateFloater (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateLabeledEntry (self, parent, category, text, help='', command=None, value='', width=12, relief=SUNKEN, side=LEFT, fill=X, expand=0)
| newCreateOptionMenu (self, parent, category, text, help='', command=None, items=[], labelpos=W, label_anchor=W, label_width=16, menu_tearoff=1, side=LEFT, fill=X, expand=0, **kw)
| newCreateRadiobutton (self, parent, category, text, variable, value, command=None, help='', anchor=W, side=LEFT, fill=X, expand=0, **kw)
| newCreateSider (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateVector2Entry (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| newCreateVector3Entry (self, parent, category, text, help='', command=None, side=LEFT, fill=X, expand=0, **kw)
| quit (self)
| showAbout (self)
| toggleBalloon (self)
| transformRGB (self, rgb, max=1.0)
| updateProgress (self, newValue=0, newMax=0)
Public Member Functions inherited from DirectObject
| __init__ (self)
| accept (self, event, method, extraArgs=[])
| acceptOnce (self, event, method, extraArgs=[])
| addTask (self, *args, **kwargs)
| detectLeaks (self)
| doMethodLater (self, *args, **kwargs)
| getAllAccepting (self)
| ignore (self, event)
| ignoreAll (self)
| isAccepting (self, event)
| isIgnoring (self, event)
| removeAllTasks (self)
| removeTask (self, taskOrName)

## Public Attributes
list | actionEvents
| addKeyframe
| cCam = self.cCamera.attachNewNode(self.cCamNode)
| cCamera = render.attachNewNode('cCamera')
| cCamNode = Camera('cCam')
| cDr = self.cLayer.makeDisplayRegion(0.6, 1.0, 0, 0.4)
| cLayer = chan.makeLayer(1)
| cLens = PerspectiveLens()
float | controlStart = 0.0
float | controlStop = 0.0
| cropCurve
float | cropFrom = 0.0
| cropPage = self.mainNotebook.add('Crop')
float | cropTo = 0.0
| curveCollection = None
| curveEditTask = self.playbackMarker.id():
| curveFitter = CurveFitter()
| curveNodePath
float | deltaTime = 0.0
int | desampleFrequency = 1
| drawPage = self.mainNotebook.add('Draw')
| extendPage = self.mainNotebook.add('Extend')
| faceForward = 1)
int | fAdjustingValues = 0
int | hasPoints = 0
| iRay = SelectionRay(self.iRayCS)
| iRayCS
str | keyframeHook = 'f10'
| lastPos = Point3(0)
int | layerIndex = 1
int | loopPlayback = 1
| mainNotebook = Pmw.NoteBook(interior)
| makeEven = Frame(resampleFrame)
| manipulandumId = None
float | maxT = 0.0
| name = self['name']
| nodePath = self['nodePath']
dict | nodePathDict = {}
| nodePathMenu
tuple | nodePathMenuBG
tuple | nodePathMenuEntry
list | nodePathNames = ['marker', 'camera', 'selected']
| nodePathParent = render
int | numSamples = 100
int | numSegs = 40
int | numTicks = 1
| nurbsCurveDrawer = NurbsCurveDrawer()
| oldPlaybackNodePath = None
| optionsPage = self.mainNotebook.add('Options')
| playbackMarker = loader.loadModel('models/misc/smiley')
| playbackMarkerIds
| playbackNodePath = self.nodePath
float | playbackSF = 1.0
float | playbackTime = 0.0
list | pointSet = []
int | pointSetCount = 0
dict | pointSetDict = {}
str | pointSetName = self.name + '-ps-' + repr(self.pointSetCount)
list | postPoints = []
list | prePoints = []
| preRecordFunc = None
| recorderNodePath = base.direct.group.attachNewNode(self.name)
| recordingType = StringVar()
float | recordStart = 0.0
float | recordStop = 0.0
| redoButton
| refinePage = self.mainNotebook.add('Refine')
| resamplePage = self.mainNotebook.add('Resample')
str | samplingMode = 'Continuous'
| selectPointSetNamed
| setLoopPlayback = (('MSSansSerif', 12, 'bold'))
| sf = Pmw.ScrolledFrame(self.drawPage, horizflex = 'elastic')
| speedEntry
| speedScale
| speedVar = StringVar()
str | startStopHook = 'f6'
| tangentGroup = self.playbackMarker.attachNewNode('Tangent Group')
| tangentLines = LineNodePath(self.tangentGroup)
| tangentMarker = loader.loadModel('models/misc/sphere')
| tangentMarkerIds
| tempCS
| toggleRecordVar
| trace = LineNodePath(self.recorderNodePath)
| undoButton
Public Attributes inherited from AppShell
| about
| dataArea
str | id = self.appname + '-' + repr(AppShell.panelCount)
| menuBar
| menuFrame = Frame(self._hull)
| parent = Toplevel()
| toggleBalloonVar = IntVar()
dict | variableDict = {}
dict | widgetDict = {}

## Static Public Attributes
int | count = 0
Static Public Attributes inherited from AppShell
str | appname = 'Generic Application Frame'
str | appversion = '1.0'
str | balloonState = 'none'
str | contactemail = 'Mark.Mine@disney.com'
str | contactname = 'Mark R. Mine'
str | contactphone = '(818) 544-2921'
tuple | copyright
int | frameHeight = 320
int | frameWidth = 450
int | padx = 5
int | pady = 5
int | panelCount = 0
int | usecommandarea = 0
int | usestatusarea = 0
Static Public Attributes inherited from DirectObject
| accept_once = acceptOnce
| add_task = addTask
| detect_leaks = detectLeaks
| do_method_later = doMethodLater
| get_all_accepting = getAllAccepting
| ignore_all = ignoreAll
| is_accepting = isAccepting
| is_ignoring = isIgnoring
| remove_all_tasks = removeAllTasks
| remove_task = removeTask

## Additional Inherited Members
Protected Member Functions inherited from DirectObject
| _addTask (self, task)
| _clearTask (self, task)
Protected Attributes inherited from AppShell
| _hull = self.component('hull')
Protected Attributes inherited from DirectObject
dict | _taskList = {}

## Constructor & Destructor Documentation

## ◆ __init__()

__init__ | ( |  | self,
|  |  | parent = None,
|  | ** | kw )

## Member Function Documentation

## ◆ addKeyframe()

addKeyframe | ( |  | self,
|  |  | fToggleRecord = 1 )

## ◆ addNodePath()

addNodePath | ( |  | self,
|  |  | nodePath )

## ◆ addNodePathToDict()

addNodePathToDict | ( |  | self,
|  |  | nodePath,
|  |  | names,
|  |  | menu,
|  |  | dict )

## ◆ addWidget()

addWidget | ( |  | self,
|  |  | widget,
|  |  | category,
|  |  | text )

WIDGET UTILITY FUNCTIONS ##.

Reimplemented from AppShell.

## ◆ appInit()

appInit | ( |  | self | ) |

USER METHODS ### To be overridden.

Reimplemented from AppShell.

## ◆ computeCurves()

computeCurves | ( |  | self | ) |

## ◆ createAngleDial()

createAngleDial | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createButton()

createButton | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command,
|  |  | side = 'top',
|  |  | expand = 0,
|  |  | fill = X )

## ◆ createCheckbutton()

createCheckbutton | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command,
|  |  | initialState,
|  |  | side = 'top',
|  |  | fill = X,
|  |  | expand = 0 )

## ◆ createColorEntry()

createColorEntry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createComboBox()

createComboBox | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | items,
|  |  | command,
|  |  | history = 0,
|  |  | side = LEFT,
|  |  | expand = 0,
|  |  | fill = X )

## ◆ createEntryScale()

createEntryScale | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  |  | min = 0.0,
|  |  | max = 1.0,
|  |  | resolution = None,
|  |  | side = TOP,
|  |  | fill = X,
|  |  | expand = 1,
|  | ** | kw )

## ◆ createFloater()

createFloater | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  |  | min = 0.0,
|  |  | resolution = None,
|  |  | maxVelocity = 10.0,
|  | ** | kw )

## ◆ createInterface()

createInterface | ( |  | self | ) |

Reimplemented from AppShell.

## ◆ createLabeledEntry()

createLabeledEntry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | value = '',
|  |  | command = None,
|  |  | relief = 'sunken',
|  |  | side = LEFT,
|  |  | expand = 1,
|  |  | width = 12 )

## ◆ createNewPointSet()

createNewPointSet | ( |  | self | ) |

## ◆ createOptionMenu()

createOptionMenu | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | items,
|  |  | command )

## ◆ createRadiobutton()

createRadiobutton | ( |  | self,
|  |  | parent,
|  |  | side,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | variable,
|  |  | value,
|  |  | command = None,
|  |  | fill = X,
|  |  | expand = 0 )

## ◆ createSlider()

createSlider | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  |  | min = 0.0,
|  |  | max = 1.0,
|  |  | resolution = None,
|  |  | side = TOP,
|  |  | fill = X,
|  |  | expand = 1,
|  | ** | kw )

## ◆ createVector2Entry()

createVector2Entry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ createVector3Entry()

createVector3Entry | ( |  | self,
|  |  | parent,
|  |  | category,
|  |  | text,
|  |  | balloonHelp,
|  |  | command = None,
|  | ** | kw )

## ◆ cropCurve()

cropCurve | ( |  | self | ) |

## ◆ curveEditTask()

curveEditTask | ( |  | self,
|  |  | state )

## ◆ desampleCurve()

desampleCurve | ( |  | self | ) |

## ◆ deselectedNodePathHook()

deselectedNodePathHook | ( |  | self,
|  |  | nodePath )

    Hook called upon deselection of a node path used to select playback
    marker if subnode selected

## ◆ disableKeyframeButton()

disableKeyframeButton | ( |  | self | ) |

## ◆ easeInOut()

easeInOut | ( |  | self,
|  |  | t )

## ◆ enableKeyframeButton()

enableKeyframeButton | ( |  | self | ) |

## ◆ extractPointSetFromCurveCollection()

extractPointSetFromCurveCollection | ( |  | self | ) |

## ◆ extractPointSetFromCurveFitter()

extractPointSetFromCurveFitter | ( |  | self | ) |

## ◆ faceForward()

faceForward | ( |  | self | ) |

## ◆ followTerrain()

followTerrain | ( |  | self,
|  |  | height = 1.0 )

## ◆ getChildIds()

getChildIds | ( |  | self,
|  |  | nodePath )

## ◆ getPostPoints()

getPostPoints | ( |  | self | ) |

## ◆ getPrePoints()

getPrePoints | ( |  | self,
|  |  | type = 'Refine' )

## ◆ getVariable()

getVariable | ( |  | self,
|  |  | category,
|  |  | text )

Reimplemented from AppShell.

## ◆ getWidget()

getWidget | ( |  | self,
|  |  | category,
|  |  | text )

Reimplemented from AppShell.

## ◆ initTrace()

initTrace | ( |  | self | ) |

## ◆ jumpToEndOfPlayback()

jumpToEndOfPlayback | ( |  | self | ) |

## ◆ jumpToStartOfPlayback()

jumpToStartOfPlayback | ( |  | self | ) |

## ◆ loadCurveFromFile()

loadCurveFromFile | ( |  | self | ) |

## ◆ makeCameraWindow()

makeCameraWindow | ( |  | self | ) |

## ◆ makeEven()

makeEven | ( |  | self | ) |

## ◆ manipulateObjectCleanupHook()

manipulateObjectCleanupHook | ( |  | self,
|  |  | nodePathList = [] )

## ◆ manipulateObjectStartHook()

manipulateObjectStartHook | ( |  | self | ) |

## ◆ mergePoints()

mergePoints | ( |  | self | ) |

## ◆ onDestroy()

onDestroy | ( |  | self,
|  |  | event )

Reimplemented from AppShell.

## ◆ playbackGoTo()

playbackGoTo | ( |  | self,
|  |  | time )

## ◆ playbackTask()

playbackTask | ( |  | self,
|  |  | state )

## ◆ pushRedo()

pushRedo | ( |  | self | ) |

## ◆ pushRedoHook()

pushRedoHook | ( |  | self | ) |

## ◆ pushUndo()

pushUndo | ( |  | self,
|  |  | fResetRedo = 1 )

## ◆ pushUndoHook()

pushUndoHook | ( |  | self | ) |

## ◆ recordPoint()

recordPoint | ( |  | self,
|  |  | time )

## ◆ recordTask()

recordTask | ( |  | self,
|  |  | state )

## ◆ redoHook()

redoHook | ( |  | self,
|  |  | nodePathList = [] )

## ◆ redoListEmptyHook()

redoListEmptyHook | ( |  | self | ) |

## ◆ reset()

reset | ( |  | self | ) |

## ◆ sampleCurve()

sampleCurve | ( |  | self,
|  |  | fCompute = 1 )

## ◆ saveCurveToFile()

saveCurveToFile | ( |  | self | ) |

## ◆ selectedNodePathHook()

selectedNodePathHook | ( |  | self,
|  |  | nodePath )

    Hook called upon selection of a node path used to select playback
    marker if subnode selected

## ◆ selectNodePathNamed()

selectNodePathNamed | ( |  | self,
|  |  | name )

## ◆ selectPointSetNamed()

selectPointSetNamed | ( |  | self,
|  |  | name )

## ◆ setControlStart()

setControlStart | ( |  | self,
|  |  | value )

## ◆ setControlStop()

setControlStop | ( |  | self,
|  |  | value )

## ◆ setCropFrom()

setCropFrom | ( |  | self,
|  |  | value )

## ◆ setCropTo()

setCropTo | ( |  | self,
|  |  | value )

## ◆ setCvColor()

setCvColor | ( |  | self,
|  |  | color )

## ◆ setCvVis()

setCvVis | ( |  | self | ) |

## ◆ setDesampleFrequency()

setDesampleFrequency | ( |  | self,
|  |  | frequency )

## ◆ setExtendMode()

setExtendMode | ( |  | self | ) |

## ◆ setHullColor()

setHullColor | ( |  | self,
|  |  | color )

## ◆ setHullVis()

setHullVis | ( |  | self | ) |

## ◆ setKeyframeHook()

setKeyframeHook | ( |  | self,
|  |  | event = None )

## ◆ setKnotColor()

setKnotColor | ( |  | self,
|  |  | color )

## ◆ setKnotVis()

setKnotVis | ( |  | self | ) |

## ◆ setLoopPlayback()

setLoopPlayback | ( |  | self | ) |

## ◆ setMarkerVis()

setMarkerVis | ( |  | self | ) |

## ◆ setNewCurveMode()

setNewCurveMode | ( |  | self | ) |

## ◆ setNodePath()

setNodePath | ( |  | self,
|  |  | nodePath )

## ◆ setNumSamples()

setNumSamples | ( |  | self,
|  |  | numSamples )

## ◆ setNumSegs()

setNumSegs | ( |  | self,
|  |  | value )

## ◆ setNumTicks()

setNumTicks | ( |  | self,
|  |  | value )

## ◆ setPathColor()

setPathColor | ( |  | self,
|  |  | color )

## ◆ setPathDuration()

setPathDuration | ( |  | self,
|  |  | event )

## ◆ setPathDurationTo()

setPathDurationTo | ( |  | self,
|  |  | newMaxT )

## ◆ setPathVis()

setPathVis | ( |  | self | ) |

## ◆ setPlaybackNodePath()

setPlaybackNodePath | ( |  | self,
|  |  | nodePath )

## ◆ setPlaybackSF()

setPlaybackSF | ( |  | self,
|  |  | value )

## ◆ setPreRecordFunc()

setPreRecordFunc | ( |  | self,
|  |  | func )

## ◆ setRecordingType()

setRecordingType | ( |  | self,
|  |  | type )

## ◆ setRecordStart()

setRecordStart | ( |  | self,
|  |  | value )

## ◆ setRefineMode()

setRefineMode | ( |  | self | ) |

## ◆ setRefineStop()

setRefineStop | ( |  | self,
|  |  | value )

## ◆ setSamplingMode()

setSamplingMode | ( |  | self,
|  |  | mode )

## ◆ setSpeedScale()

setSpeedScale | ( |  | self,
|  |  | value )

## ◆ setStartStopHook()

setStartStopHook | ( |  | self,
|  |  | event = None )

## ◆ setTickColor()

setTickColor | ( |  | self,
|  |  | color )

## ◆ setTickScale()

setTickScale | ( |  | self,
|  |  | value )

## ◆ setTraceVis()

setTraceVis | ( |  | self | ) |

## ◆ startPlayback()

startPlayback | ( |  | self | ) |

## ◆ startStopPlayback()

startStopPlayback | ( |  | self | ) |

## ◆ stopPlayback()

stopPlayback | ( |  | self | ) |

## ◆ toggleRecord()

toggleRecord | ( |  | self | ) |

## ◆ toggleRecordVar()

toggleRecordVar | ( |  | self | ) |

## ◆ undoHook()

undoHook | ( |  | self,
|  |  | nodePathList = [] )

## ◆ undoListEmptyHook()

undoListEmptyHook | ( |  | self | ) |

## ◆ updateWidgets()

updateWidgets | ( |  | self | ) |

## Member Data Documentation

## ◆ actionEvents

list actionEvents

Initial value:
= [
('DIRECT_undo', self.undoHook),
('DIRECT_pushUndo', self.pushUndoHook),
('DIRECT_undoListEmpty', self.undoListEmptyHook),
('DIRECT_redo', self.redoHook),
('DIRECT_pushRedo', self.pushRedoHook),
('DIRECT_redoListEmpty', self.redoListEmptyHook),
('DIRECT_selectedNodePath', self.selectedNodePathHook),
('DIRECT_deselectedNodePath', self.deselectedNodePathHook),
('DIRECT_manipulateObjectStart', self.manipulateObjectStartHook),
('DIRECT_manipulateObjectCleanup',
self.manipulateObjectCleanupHook),
]

## ◆ addKeyframe

addKeyframe

## ◆ cCam

cCam = self.cCamera.attachNewNode(self.cCamNode)

## ◆ cCamera

cCamera = render.attachNewNode('cCamera')

## ◆ cCamNode

cCamNode = Camera('cCam')

## ◆ cDr

cDr = self.cLayer.makeDisplayRegion(0.6, 1.0, 0, 0.4)

## ◆ cLayer

cLayer = chan.makeLayer(1)

## ◆ cLens

cLens = PerspectiveLens()

## ◆ controlStart

controlStart = 0.0

## ◆ controlStop

controlStop = 0.0

## ◆ count

int count = 0
| static

## ◆ cropCurve

cropCurve

Initial value:
= self.createSlider(
cropFrame,
'Crop Page', 'Crop To',
'Delete all curve points after this time',
resolution = 0.01,
command = self.setCropTo)

## ◆ cropFrom

cropFrom = 0.0

## ◆ cropPage

cropPage = self.mainNotebook.add('Crop')

## ◆ cropTo

cropTo = 0.0

## ◆ curveCollection

curveCollection = None

## ◆ curveEditTask

curveEditTask = self.playbackMarker.id():

## ◆ curveFitter

curveFitter = CurveFitter()

## ◆ curveNodePath

curveNodePath

Initial value:
= self.recorderNodePath.attachNewNode(
self.nurbsCurveDrawer.getGeomNode())

## ◆ deltaTime

deltaTime = 0.0

## ◆ desampleFrequency

desampleFrequency = 1

## ◆ drawPage

drawPage = self.mainNotebook.add('Draw')

## ◆ extendPage

extendPage = self.mainNotebook.add('Extend')

## ◆ faceForward

faceForward = 1)

## ◆ fAdjustingValues

int fAdjustingValues = 0

## ◆ hasPoints

int hasPoints = 0

## ◆ iRay

iRay = SelectionRay(self.iRayCS)

## ◆ iRayCS

iRayCS

Initial value:
= self.recorderNodePath.attachNewNode(
'mopathRecorderIRayCS')

## ◆ keyframeHook

keyframeHook = 'f10'

## ◆ lastPos

lastPos = Point3(0)

## ◆ layerIndex

int layerIndex = 1

## ◆ loopPlayback

loopPlayback = 1

## ◆ mainNotebook

mainNotebook = Pmw.NoteBook(interior)

## ◆ makeEven

makeEven = Frame(resampleFrame)

## ◆ manipulandumId

manipulandumId = None

## ◆ maxT

maxT = 0.0

## ◆ name

name = self['name']

## ◆ nodePath

nodePath = self['nodePath']

## ◆ nodePathDict

nodePathDict = {}

## ◆ nodePathMenu

nodePathMenu

Initial value:
= Pmw.ComboBox(
frame, entry_width = 20,
selectioncommand = self.selectNodePathNamed,
scrolledlist_items = self.nodePathNames)

## ◆ nodePathMenuBG

tuple nodePathMenuBG

Initial value:
= (
self.nodePathMenuEntry.configure('background')[3])

## ◆ nodePathMenuEntry

tuple nodePathMenuEntry

Initial value:
= (
self.nodePathMenu.component('entryfield_entry'))

## ◆ nodePathNames

nodePathNames = ['marker', 'camera', 'selected']

## ◆ nodePathParent

nodePathParent = render

## ◆ numSamples

numSamples = 100

## ◆ numSegs

numSegs = 40

## ◆ numTicks

int numTicks = 1

## ◆ nurbsCurveDrawer

nurbsCurveDrawer = NurbsCurveDrawer()

## ◆ oldPlaybackNodePath

oldPlaybackNodePath = None

## ◆ optionsPage

optionsPage = self.mainNotebook.add('Options')

## ◆ playbackMarker

playbackMarker = loader.loadModel('models/misc/smiley')

## ◆ playbackMarkerIds

playbackMarkerIds

Initial value:
= self.getChildIds(
self.playbackMarker.getChild(0))

## ◆ playbackNodePath

playbackNodePath = self.nodePath

## ◆ playbackSF

playbackSF = 1.0

## ◆ playbackTime

playbackTime = 0.0

## ◆ pointSet

pointSet = []

## ◆ pointSetCount

int pointSetCount = 0

## ◆ pointSetDict

dict pointSetDict = {}

## ◆ pointSetName

pointSetName = self.name + '-ps-' + repr(self.pointSetCount)

## ◆ postPoints

list postPoints = []

## ◆ prePoints

list prePoints = []

## ◆ preRecordFunc

preRecordFunc = None

## ◆ recorderNodePath

recorderNodePath = base.direct.group.attachNewNode(self.name)

## ◆ recordingType

recordingType = StringVar()

## ◆ recordStart

recordStart = 0.0

## ◆ recordStop

recordStop = 0.0

## ◆ redoButton

redoButton

Initial value:
= Button(self.menuFrame, text = 'Redo',
command = base.direct.redo)

## ◆ refinePage

refinePage = self.mainNotebook.add('Refine')

## ◆ resamplePage

resamplePage = self.mainNotebook.add('Resample')

## ◆ samplingMode

str samplingMode = 'Continuous'

## ◆ selectPointSetNamed

selectPointSetNamed

## ◆ setLoopPlayback

setLoopPlayback = (('MSSansSerif', 12, 'bold'))

## ◆ sf

sf = Pmw.ScrolledFrame(self.drawPage, horizflex = 'elastic')

## ◆ speedEntry

speedEntry

Initial value:
= Entry(frame, textvariable = self.speedVar,
width = 8)

## ◆ speedScale

speedScale

Initial value:
= Scale(frame, from_ = -1, to = 1,
resolution = 0.01, showvalue = 0,
width = 10, orient = 'horizontal',
command = self.setPlaybackSF)

## ◆ speedVar

speedVar = StringVar()

## ◆ startStopHook

startStopHook = 'f6'

## ◆ tangentGroup

tangentGroup = self.playbackMarker.attachNewNode('Tangent Group')

## ◆ tangentLines

tangentLines = LineNodePath(self.tangentGroup)

## ◆ tangentMarker

tangentMarker = loader.loadModel('models/misc/sphere')

## ◆ tangentMarkerIds

tangentMarkerIds

Initial value:
= self.getChildIds(
self.tangentMarker.getChild(0))

## ◆ tempCS

tempCS

Initial value:
= self.recorderNodePath.attachNewNode(
'mopathRecorderTempCS')

## ◆ toggleRecordVar

toggleRecordVar

## ◆ trace

trace = LineNodePath(self.recorderNodePath)

## ◆ undoButton

undoButton

Initial value:
= Button(self.menuFrame, text = 'Undo',
command = base.direct.undo)